package com.the5gi.events;

import com.the5gi.util.Role;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.*;

public class GameStartTTTEvent extends Event {

    private static final HandlerList HANDLER_LIST = new HandlerList();

    private static JavaPlugin plugin;

    private static int[] roleAmountScheme;

    private static Map<Player, Role> playerRoles = new HashMap<>();

    //private static List<Role> playerRoles = new ArrayList<>();

    //get

    private static List<Player> participatingPlayers = new ArrayList<>();



    public GameStartTTTEvent(JavaPlugin plugin, int[] roleAmountScheme, List<Player> participatingPlayers) {
        GameStartTTTEvent.plugin = plugin;
        GameStartTTTEvent.roleAmountScheme = roleAmountScheme;
        GameStartTTTEvent.participatingPlayers = participatingPlayers;
    }

    public JavaPlugin getPlugin() {
        return plugin;
    }


    public int[] getRoleAmountScheme() {
        return roleAmountScheme;
    }

    public Map<Player, Role> getPlayerRoles() {
        return playerRoles;
    }

    public void setPlayerRole(Player player, Role role) {
        playerRoles.put(player, role);
    }

    public Role getPlayerRole(Player player) {
        return playerRoles.get(player);
    }

    public boolean playerHasRole(Player player) {
        Role playerRole = getPlayerRole(player);

        if (playerRole != null) {
            return true;
        }

        return false;
    }

    public List<Player> getParticipatingPlayers() {
        return participatingPlayers;
    }

    public Role getRandomRole() {

        Role returnRole = null;

        Random rand = new Random();
        int randomInt = rand.nextInt(9);

        switch (randomInt) {
            case 0:
                returnRole = Role.DETECTIVE;
                break;
            case 1:
                returnRole = Role.SHERIFF;
                break;
            case 2:
                returnRole = Role.SURVIVALISTS;
                break;
            case 3:
                returnRole = Role.MERCENARIES;
                break;
            case 4:
                returnRole = Role.TRAITORS;
                break;
            case 5:
                returnRole = Role.ASSASSINS;
                break;
            case 6:
                returnRole = Role.LONEWOLF;
                break;
            case 7:
                returnRole = Role.JESTER;
                break;
            case 8:
                returnRole = Role.INNOCENT;
                break;
        }

        return returnRole;
    }




    @Override
    public HandlerList getHandlers() {
        return HANDLER_LIST;
    }

    public static HandlerList getHandlerList() {
        return HANDLER_LIST;
    }
}
