package com.the5gi.events;

import com.the5gi.util.Role;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class TTTGamesOnEvent extends Event {

    private static final HandlerList HANDLER_LIST = new HandlerList();

    private static JavaPlugin plugin;

    private List<Player> participatingPlayers = new ArrayList<>();
    private Map<Player, Role> playerRoles;
    private int[] roleAmounts = {0,0,0,0,0,0,0,0};


    public TTTGamesOnEvent(JavaPlugin plugin, List<Player> participatingPlayers, Map<Player, Role> playerRoles, int[] roleAmounts) {
        this.plugin = plugin;
        this.participatingPlayers = participatingPlayers;
        this.playerRoles = playerRoles;
        this.roleAmounts = roleAmounts;

    }

    public int[] getRoleAmounts() {
        return roleAmounts;
    }

    public JavaPlugin getPlugin() {
        return plugin;
    }

    public List<Player> getPlayers() {
        return participatingPlayers;
    }

    public Role getPlayerRole(Player player) {
        return playerRoles.get(player);
    }

    public Role getPlayerRoleByInt(int playerInt) {
        return playerRoles.get(playerInt);
    }

    @Override
    public HandlerList getHandlers() {
        return HANDLER_LIST;
    }

    public static HandlerList getHandlerList() {
        return HANDLER_LIST;
    }
}
