package com.the5gi.listeners;

import com.the5gi.events.GameStartTTTEvent;
import com.the5gi.events.TTTGamesOnEvent;
import com.the5gi.util.Role;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class GameStartTTTListener implements Listener {
    private static int gameTaskId = -1;
    private static boolean called = false;

    @EventHandler
    public static void gameStartListener(GameStartTTTEvent event) {
        int[] desiredAmounts = event.getRoleAmountScheme();
        int[] amounts = desiredAmounts;

        for (Player player : event.getParticipatingPlayers()) {
            if (!event.playerHasRole(player)) {
                boolean roleIsUnavailable = true;
                Role role;
                while (roleIsUnavailable) {
                    role = event.getRandomRole();
                    if (amounts[role.getId()] < 1) {
                        System.out.println(amounts[role.getId()]);
                        continue;
                    }
                    event.setPlayerRole(player, role);
                    amounts[role.getId()]--;
                    roleIsUnavailable = false;
                }
                System.out.println("End while loop");
            }
        }
        System.out.println("End for loop");

        gameTaskId = Bukkit.getServer().getScheduler().scheduleSyncRepeatingTask(event.getPlugin(), () -> {
            if (!called) {
                TTTGamesOnEvent gameOnEvent = new TTTGamesOnEvent(event.getPlugin(), event.getParticipatingPlayers(), event.getPlayerRoles(), desiredAmounts);
                event.getPlugin().getServer().getPluginManager().callEvent(gameOnEvent);
                event.getPlugin().getServer().getScheduler().cancelTask(gameTaskId);
            }
        }, 20 , 1);

    }
}
