package com.the5gi.listeners;

import com.the5gi.SimpleTTTCore;
import com.the5gi.events.TTTGamesOnEvent;
import com.the5gi.util.*;
import net.md_5.bungee.api.ChatMessageType;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.boss.BarColor;
import org.bukkit.boss.BarStyle;
import org.bukkit.boss.BossBar;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class GamesOnTTTListener implements Listener {

    private static int gamesOnTaskId = -1;
    private static int timeLeft = 300;

    public static int playersLeft = -1;

    private static boolean doRush = true;

    @EventHandler
    public static void gamesOnEvent(TTTGamesOnEvent event) {
        playersLeft = event.getPlayers().size();
        for (Player player : event.getPlayers()) {
            System.out.println(event.getPlayerRole(player));
            ChatColor roleColor = RoleColorHelper.getChatColorOfRole(event.getPlayerRole(player));
            player.sendTitle("Your role is: " + roleColor + event.getPlayerRole(player).toString(), "", 20, 80, 20);
            player.spigot().sendMessage(ChatMessageType.ACTION_BAR, new TextComponent(roleColor + RoleDescriptionHelper.getRoleDescription(event.getPlayerRole(player))));
        }

        BossBar bossBar = Bukkit.createBossBar("Time Left: -1s", BarColor.YELLOW, BarStyle.SOLID);
        for (Player player : event.getPlayers()) {
            bossBar.addPlayer(player);
        }
        gamesOnTaskId = Bukkit.getServer().getScheduler().scheduleSyncRepeatingTask(event.getPlugin(), () -> {
            if (timeLeft == -1) {
                bossBar.setTitle("Time Left: " + "Overtime");
                bossBar.setColor(BarColor.RED);
            } else if (timeLeft != 0) {
                bossBar.setTitle("Time Left: " + timeLeft + "s");

                if (timeLeft <= 10) {
                    bossBar.setColor(BarColor.RED);
                } else if (timeLeft > 30) {
                    bossBar.setColor(BarColor.GREEN);
                } else if (timeLeft > 10 && timeLeft < 30) {
                    bossBar.setColor(BarColor.YELLOW);
                } else {
                    bossBar.setColor(BarColor.WHITE);
                }
                timeLeft--;
            } else if (timeLeft == 0) {
                //DONE Make this not fail with null value after time is up
                if (GameHelper.getGameDecision(event.getRoleAmounts(), playersLeft, doRush).equals(GameDecision.RUSH)) {
                    doRush = false;
                    timeLeft = 120;
                } else if (GameHelper.getGameDecision(event.getRoleAmounts(), playersLeft, doRush).equals(GameDecision.OVERTIME)) {
                    timeLeft = -1;
                } else if (GameHelper.getGameDecision(event.getRoleAmounts(), playersLeft, doRush).equals(GameDecision.END)) {
                    bossBar.removeAll();
                    for (Player player : event.getPlugin().getServer().getOnlinePlayers()) {
                        player.sendTitle(RoleWinnerHelper.getTitle(GameHelper.getWinner()), "", 10, 60, 10);
                    }
                    SimpleTTTCore.startGame(event.getPlugin());
                    event.getPlugin().getServer().getScheduler().cancelTask(gamesOnTaskId);
                }
            }
        }, 20 , 20);


    }
}
