package com.the5gi.listeners;

import com.the5gi.SimpleTTTCore;
import com.the5gi.events.GameStartTTTEvent;
import com.the5gi.events.PreStartTTTEvent;
import com.the5gi.util.RoleAmountHelper;
import org.bukkit.Bukkit;
import org.bukkit.boss.BarColor;
import org.bukkit.boss.BarStyle;
import org.bukkit.boss.BossBar;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.plugin.Plugin;

import java.util.ArrayList;
import java.util.List;

public class PreStartTTTListener implements Listener {
    private Plugin plugin;
    private static int timeLeft = 30;
    private static BossBar bossBar;
    public static int taskId = -1;

    @EventHandler
    public static void onStart(PreStartTTTEvent event) {
        event.getPlugin().getServer().getScheduler().cancelTask(SimpleTTTCore.taskId);
        bossBar = Bukkit.createBossBar("Starting in: null", BarColor.YELLOW, BarStyle.SOLID);
        taskId = Bukkit.getServer().getScheduler().scheduleSyncRepeatingTask(event.getPlugin(), () -> {
            if (event.getPlugin().getServer().getOnlinePlayers().size() >= 2) {
                if (timeLeft == 0) {
                    bossBar.setTitle("Starting Game...");
                    bossBar.setColor(BarColor.YELLOW);
                    bossBar.removeAll();
                    List<Player> players = new ArrayList<>();
                    for (Player player : event.getPlugin().getServer().getOnlinePlayers()) {
                        players.add(player);
                    }
                    GameStartTTTEvent gameStartTTTEvent = new GameStartTTTEvent(event.getPlugin(), RoleAmountHelper.getAmountOfRoles(event.getPlugin().getServer().getOnlinePlayers().size()), players);
                    event.getPlugin().getServer().getPluginManager().callEvent(gameStartTTTEvent);
                    event.getPlugin().getServer().getScheduler().cancelTask(taskId);
                } else if (timeLeft != 0) {
                    bossBar.setTitle("Starting in: " + timeLeft + "s");
                    bossBar.setColor(BarColor.GREEN);
                    timeLeft--;
                }
            } else {
                bossBar.setTitle("Not Enough Players!");
                bossBar.setColor(BarColor.RED);
                timeLeft = 30;
            }
        }, 20 , 1);

    }



}
